/* Sistemas Integrados TECNISA

Nome: LOGSERIENFTP.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   05/04/2011 - Kessiler Almeida S. Rodrigues
*/
CREATE OR REPLACE TRIGGER LOG_SERIENFTP
AFTER DELETE OR INSERT OR UPDATE
ON SERIENFTP FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(500);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_IDTIPOOPER   := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   IF UPDATING THEN
      IF NVL(:OLD.CDEMPRESA, '!')    <> NVL(:NEW.CDEMPRESA, '!')    THEN
         V_DESC   := 'Empresa '         || '' || NVL(:NEW.CDEMPRESA,  '')  || ' ';
      END IF;
      IF NVL(:OLD.CDINSCMUNI, '!')   <> NVL(:NEW.CDINSCMUNI, '!')   THEN
         V_DESC   := 'Inscr.Estadual '  || '' || NVL(:NEW.CDINSCESTA, '')  || ' ';
      END IF;
      IF NVL(:OLD.CDINSCESTA, '!')   <> NVL(:NEW.CDINSCESTA, '!')   THEN
         V_DESC   := 'Inscr.Municipal ' || '' || NVL(:NEW.CDINSCMUNI, '')  || ' ';
      END IF;
      IF NVL(:OLD.CDSERIE, '!')      <> NVL(:NEW.CDSERIE, '!')      THEN
         V_DESC   := 'Cod.Srie '       || '' || :NEW.CDSERIE              || ' ';
      END IF;
      IF NVL(:OLD.CDTIPOOPER, '!')   <> NVL(:NEW.CDTIPOOPER, '!')   THEN
         V_DESC   := 'Cod.TpOperao '  || '' || :NEW.CDTIPOOPER           || ' ';
      END IF;
      IF NVL(:OLD.IDENTRSAIDOP, '!') <> NVL(:NEW.IDENTRSAIDOP, '!') THEN
         V_DESC   := 'IdEntrSaidOp '         || '' || :NEW.IDENTRSAIDOP    || ' ';
      END IF;
      IF NVL(:OLD.NRSEQSERIENFTP, '!') <> NVL(:NEW.NRSEQSERIENFTP, '!') THEN
         V_DESC  := 'Sequencial'            || '' || :NEW.NRSEQSERIENFTP;
      END IF;
      V_ITPESQ       := NVL(:OLD.CDEMPRESA, '')||NVL(:OLD.CDINSCESTA, '')||NVL(:OLD.CDINSCMUNI, '')||NVL(:OLD.CDSERIE, '')||NVL(:OLD.CDTIPOOPER, '')||NVL(:OLD.IDENTRSAIDOP, '')||NVL(:OLD.NRSEQSERIENFTP,'');
      V_IDTIPOOPER   := '2';
   ELSE
      IF INSERTING THEN
         V_DESC   := 'Empresa '              || '' || NVL(:NEW.CDEMPRESA,    '')    || ' ' ||
                     'Inscr.Estadual '       || '' || NVL(:NEW.CDINSCESTA,   '')    || ' ' ||
                     'Inscr.Municipal '      || '' || NVL(:NEW.CDINSCMUNI,   '')    || ' ' ||
                     'Cod.Srie '            || '' || NVL(:NEW.CDSERIE,      '')    || ' ' ||
                     'Cod.TpOperao '       || '' || NVL(:NEW.CDTIPOOPER,   '')    || ' ' ||
                     'IdEntrSaidOp '         || '' || NVL(:NEW.IDENTRSAIDOP, '')    || ' ' ||
                     'Sequencial'            || '' || NVL(:NEW.NRSEQSERIENFTP,'');
         V_ITPESQ       := :NEW.CDEMPRESA||:NEW.CDINSCESTA||:NEW.CDINSCMUNI||:NEW.CDSERIE||:NEW.CDTIPOOPER||:NEW.IDENTRSAIDOP||:NEW.NRSEQSERIENFTP;
         V_IDTIPOOPER   := '1';
      ELSE
         IF DELETING THEN
            V_DESC   := 'Empresa '              || '' || NVL(:OLD.CDEMPRESA,    '')    || ' ' ||
                        'Inscr.Estadual '       || '' || NVL(:OLD.CDINSCESTA,   '')    || ' ' ||
                        'Inscr.Municipal '      || '' || NVL(:OLD.CDINSCMUNI,   '')    || ' ' ||
                        'Cod.Srie '            || '' || NVL(:OLD.CDSERIE,      '')    || ' ' ||
                        'Cod.TpOperao '       || '' || NVL(:OLD.CDTIPOOPER,   '')    || ' ' ||
                        'IdEntrSaidOp '         || '' || NVL(:OLD.IDENTRSAIDOP, '')    || ' ' ||
                        'Sequencial'            || '' || NVL(:OLD.NRSEQSERIENFTP,'');
            V_ITPESQ       := NVL(:OLD.CDEMPRESA, '')||NVL(:OLD.CDINSCESTA, '')||NVL(:OLD.CDINSCMUNI, '')||NVL(:OLD.CDSERIE, '')||NVL(:OLD.CDTIPOOPER, '')||NVL(:OLD.IDENTRSAIDOP, '')||NVL(:OLD.NRSEQSERIENFTP, '');
            V_IDTIPOOPER   := '3';
         END IF;
      END IF;
   END IF;
   V_DESC := SUBSTR(V_DESC, 1, 300);
   INSERT INTO LOGOPERA
      (NMTABELA,
       DTOPERACAO,
       NMRESPOPER,
       IDTIPOOPER,
       DSOPERACAO,
       CDPESQITEM,
       DSRDMUSUOPER,
       DSENDUSUOPER,
       DSNMUSUOPER,
       DSMETUSUOPER,
       CDORESPOPER)
    VALUES
      ('SERIENFTP',
       SYSDATE,
       NVL(V_NMOPERADOR,' '),
       V_IDTIPOOPER,
       V_DESC,
       V_ITPESQ,
       V_DSSERVERRDM,
       V_DSREMOTEADDR,
       V_DSREMOTEHOST,
       V_DSSERVMETHOD,
       V_DSREMOTEOPER);
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('LOG_SERIENFTP','5.20.xxx'); END;
/

